chiark / gitweb /
dry run fetch really does not update ref
[dgit.git] / dgit
diff --git a/dgit b/dgit
index 2e40ad7e7f8b106e68304f62a1068676a22d4751..d160e185d21910546fa395af642a2c91c032d76a 100755 (executable)
--- a/dgit
+++ b/dgit
@@ -26,8 +26,6 @@ use Dpkg::Control::Hash;
 use File::Path;
 use POSIX;
 
-open DEBUG, ">&STDERR" or die $!;
-
 our $mirror = 'http://mirror.relativity.greenend.org.uk/mirror/debian-ftp/';
 our $suite = 'sid';
 our $package;
@@ -41,12 +39,16 @@ our $aliothpath = '/git/dgit-repos';
 our $alioth_git = "git+ssh://$aliothname/$aliothpath";
 our $alioth_sshtestbodge = [$aliothname,$aliothpath];
 
+our %format_ok = map { $_=>1 } ("1.0","3.0 (native)","3.0 (quilt)");
+
 our (@git) = qw(git);
 our (@dget) = qw(dget);
 our (@dput) = qw(dput);
 our (@debsign) = qw(debsign);
 our $keyid;
 
+open DEBUG, ">/dev/null" or die $!;
+
 our %opts_opt_map = ('dget' => \@dget,
                     'dput' => \@dput,
                     'debsign' => \@debsign);
@@ -55,11 +57,18 @@ our $remotename = 'dgit';
 our $ourdscfield = 'Vcs-Git-Master';
 our $branchprefix = 'dgit';
 
-sub uploadbranch () { return "$branchprefix/$suite"; }
-sub lref ($) { return "refs/heads/$_[0]"; }
-sub rref ($) { return "refs/remotes/$remotename/$_[0]"; }
+sub lbranch () { return "$branchprefix/$suite"; }
+my $lbranch_re = '^refs/heads/'.$branchprefix.'/([^/.]+)$';
+sub lref () { return "refs/heads/".lbranch(); }
+sub lrref () { return "refs/remotes/$remotename/$suite"; }
+sub rrref () { return "refs/$branchprefix/$suite"; }
 sub debiantag ($) { return "debian/$_[0]"; }
 
+sub fetchspec () {
+    local $suite = '*';
+    return  "+".rrref().":".lrref();
+}
+
 our $ua;
 
 sub url_get {
@@ -67,7 +76,7 @@ sub url_get {
        $ua = LWP::UserAgent->new();
        $ua->env_proxy;
     }
-    print DEBUG "fetching @_...\n";
+    print "downloading @_...\n";
     my $r = $ua->get(@_) or die $!;
     die "$_[0]: ".$r->status_line."; failed.\n" unless $r->is_success;
     return $r->decoded_content();
@@ -75,12 +84,30 @@ sub url_get {
 
 our ($dscdata,$dscurl,$dsc);
 
+sub printcmd {
+    my $fh = shift @_;
+    my $intro = shift @_;
+    print $fh $intro or die $!;
+    local $_;
+    foreach my $a (@_) {
+       $_ = $a;
+       if (s{['\\]}{\\$&}g || m{\s} || m{[^-_./0-9a-z]}i) {
+           print $fh " '$_'" or die $!;
+       } else {
+           print $fh " $_" or die $!;
+       }
+    }
+    print $fh "\n" or die $!;
+}
+
 sub runcmd {
+    printcmd(\*DEBUG,"+",@_);
     $!=0; $?=0;
     die "@_ $! $?" if system @_;
 }
 
 sub cmdoutput_errok {
+    printcmd(\*DEBUG,"|",@_);
     open P, "-|", @_ or die $!;
     my $d;
     $!=0; $?=0;
@@ -98,17 +125,7 @@ sub cmdoutput {
 }
 
 sub dryrun_report {
-    print "#" or die $!;
-    local $_;
-    foreach my $a (@_) {
-       $_ = $a;
-       if (s{['\\]}{\\$&}g || m{\s} || m{[^-_./0-9a-z]}i) {
-           print " '$_'" or die $!;
-       } else {
-           print " $_" or die $!;
-       }
-    }
-    print "\n" or die $!;
+    printcmd(\*STDOUT,"#",@_);
 }
 
 sub runcmd_ordryrun {
@@ -162,15 +179,14 @@ sub get_archive_dsc () {
     # fixme madison does not show us the component
     my $prefix = substr($package, 0, $package =~ m/^l/ ? 4 : 1);
     $dscurl = "$mirror/pool/main/$prefix/$package/${package}_$vsn.dsc";
-#print DEBUG Dumper($pdodata, $&, $dscurl);
     $dscdata = url_get($dscurl);
     my $dscfh = new IO::File \$dscdata, '<' or die $!;
-#print DEBUG Dumper($dscdata, $dscfh);
+    print DEBUG Dumper($dscdata);
     $dsc = Dpkg::Control::Hash->new(allow_pgp=>1);
     $dsc->parse($dscfh, 'dsc') or die "parsing of $dscurl failed\n";
-#print DEBUG Dumper($dsc);
+    print DEBUG Dumper($dsc);
     my $fmt = $dsc->{Format};
-    die "unsupported format $fmt, sorry\n" unless $fmt eq '1.0';
+    die "unsupported format $fmt, sorry\n" unless $format_ok{$fmt};
 }
 
 sub check_for_git () {
@@ -180,11 +196,11 @@ sub check_for_git () {
        " set -e; cd $alioth_sshtestbodge->[1];".
        " if test -d $package.git; then echo 1; else echo 0; fi".
        "'";
-    #print DEBUG "$cmd\n";
+    print DEBUG "$cmd\n";
     open P, "$cmd |" or die $!;
     $!=0; $?=0;
     my $r = <P>; close P;
-#print STDERR ">$r<\n";
+    print DEBUG ">$r<\n";
     die "$r $! $?" unless $r =~ m/^[01]$/;
     return $r+0;
 }
@@ -226,7 +242,7 @@ sub dsc_files () {
 
 sub is_orig_file ($) {
     local ($_) = @_;
-    m/\.orig\.tar\.\w+$/;
+    m/\.orig(?:-\w+)?\.tar\.\w+$/;
 }
 
 sub generate_commit_from_dsc () {
@@ -266,8 +282,8 @@ $clogp->{Changes}
 # imported by dgit from the archive
 END
     close C or die $!;
-    print "synthesised git commit from .dsc $clogp->{Version}\n";
     my $commithash = cmdoutput @git, qw(hash-object -w -t commit ../commit.tmp);
+    print "synthesised git commit from .dsc $clogp->{Version}\n";
     chdir '../../../..' or die $!;
     cmdoutput @git, qw(update-ref -m),"dgit synthesise $clogp->{Version}",
               'DGIT_ARCHIVE', $commithash;
@@ -329,12 +345,26 @@ sub is_fast_fwd ($$) {
     return rev_parse($mb) eq rev_parse($ancestor);
 }
 
+sub git_fetch_us () {
+    die "cannot dry run with fetch" if $dryrun;
+    runcmd @git, qw(fetch),$remotename,fetchspec();
+}
+
 sub fetch_from_archive () {
-    # ensures that rref(uploadbranch()) is what is actually in the archive,
+    # ensures that lrref() is what is actually in the archive,
     #  one way or another
-    my $upload_ref = rref(uploadbranch());
+    get_archive_dsc();
+    $dsc_hash = $dsc->{$ourdscfield};
+    if (defined $dsc_hash) {
+       $dsc_hash =~ m/\w+/ or die "$dsc_hash $?";
+       $dsc_hash = $&;
+       print "last upload to archive specified git hash\n";
+    } else {
+       print "last upload to archive has NO git hash\n";
+    }
+
     $!=0; $upload_hash =
-       cmdoutput_errok @git, qw(show-ref --heads), $upload_ref;
+       cmdoutput_errok @git, qw(show-ref --heads), lrref();
     die $! if $!;
     die $? unless ($?==0 && chomp $upload_hash) 
        or ($?==256 && !length $upload_hash);
@@ -354,7 +384,7 @@ sub fetch_from_archive () {
            unless is_fast_fwd($dsc_hash, $upload_hash);
     }
     if ($upload_hash ne $hash) {
-       my @upd_cmd = (@git, qw(update-ref -m), 'dgit fetch', $upload_ref, $hash);
+       my @upd_cmd = (@git, qw(update-ref -m), 'dgit fetch', lrref(), $hash);
        if (!$dryrun) {
            cmdoutput @upd_cmd;
        } else {
@@ -363,48 +393,32 @@ sub fetch_from_archive () {
     }
 }
 
-sub clone () {
+sub clone ($) {
+    my ($dstdir) = @_;
     die "dry run makes no sense with clone" if $dryrun;
-    get_archive_dsc();
-    $dsc_hash = $dsc->{$ourdscfield};
-    if (defined $dsc_hash) {
-       $dsc_hash =~ m/\w+/ or die "$dsc_hash $?";
-       $dsc_hash = $&;
-       print "last upload to archive specified git hash\n";
-    } else {
-       print "last upload to archive has NO git hash\n";
-    }
-    my $dstdir = "$package";
-    my $branch = uploadbranch();
+    mkdir $dstdir or die "$dstdir $!";
+    chdir "$dstdir" or die "$dstdir $!";
+    runcmd @git, qw(init -q);
+    runcmd @git, qw(config), "remote.$remotename.fetch", fetchspec();
+    open H, "> .git/HEAD" or die $!;
+    print H "ref: ".lref()."\n" or die $!;
+    close H or die $!;
+    runcmd @git, qw(remote add), 'origin', "$alioth_git/$package.git";
     if (check_for_git()) {
-       print "cloning existing git history\n";
-       runcmd @git, qw(clone --origin),$remotename, qw(-b), $branch, '--',
-           "$alioth_git/$package.git", $dstdir;
-       chdir "$dstdir" or die "$dstdir $!";
-       fetch_from_archive();
-       runcmd @git, qw(reset --hard), rref(uploadbranch());
+       print "fetching existing git history\n";
+       git_fetch_us();
+       runcmd @git, qw(fetch origin);
     } else {
        print "starting new git history\n";
-       mkdir $dstdir or die "$dstdir $!";
-       chdir "$dstdir" or die "$dstdir $!";
-       runcmd @git, qw(init -q);
-       open H, "> .git/HEAD" or die $!;
-       print H "ref: ".lref(uploadbranch())."\n" or die $!;
-       close H or die $!;
-       runcmd @git, qw(remote add), $remotename, "$alioth_git/$package.git";
-       runcmd "git config branch.$branch.remote $remotename";
-       runcmd "git config branch.$branch.merge ".lref(uploadbranch());
-       my $newhash = generate_commit_from_dsc();
-       runcmd @git, qw(reset --hard), $newhash;
     }
+    fetch_from_archive();
+    runcmd @git, qw(reset --hard), lrref();
     print "ready for work in $dstdir\n";
 }
 
 sub fetch () {
-    get_archive_dsc();
     if (check_for_git()) {
-       runcmd_ordryrun @git, qw(fetch -p),$remotename,
-           '+refs/heads/*:refs/remotes/origin/*';
+       git_fetch_us();
     }
     fetch_from_archive();
 }
@@ -412,7 +426,7 @@ sub fetch () {
 sub pull () {
     fetch();
     runcmd_ordryrun @git, qw(merge -m),"Merge from $suite [dgit]",
-        lref(uploadbranch());
+        lrref();
 }
 
 sub dopush () {
@@ -437,7 +451,11 @@ sub dopush () {
 #        (uploadbranch());
     $dsc->{$ourdscfield} = rev_parse('HEAD');
     $dsc->save("../$dscfn.tmp") or die $!;
-    rename "../$dscfn.tmp","../$dscfn" or die "$dscfn $!";
+    if (!$dryrun) {
+       rename "../$dscfn.tmp","../$dscfn" or die "$dscfn $!";
+    } else {
+       print "[new .dsc left in $dscfn.tmp]\n";
+    }
     if (!$changesfile) {
        my $pat = "../${package}_$clogp->{Version}_*.changes";
        my @cs = glob $pat;
@@ -452,7 +470,7 @@ sub dopush () {
            " cd $package.git;".
            " if ! test -d objects; then git init --bare; fi";
     }
-    runcmd_ordryrun @git, qw(push),$remotename,"HEAD:".lref(uploadbranch());
+    runcmd_ordryrun @git, qw(push),$remotename,"HEAD:".rrref();
     if ($sign) {
        my @tag_cmd = (@git, qw(tag -s -m),
                       "Release $dsc->{Version} for $suite [dgit]");
@@ -469,20 +487,26 @@ sub dopush () {
 }
 
 sub cmd_clone {
+    my $dstdir;
     if (@ARGV==1) {
        ($package) = @ARGV;
-    } elsif (@ARGV==2) {
+    } elsif (@ARGV==2 && $ARGV[1] =~ m#^\w#) {
        ($package,$suite) = @ARGV;
+    } elsif (@ARGV==2 && $ARGV[1] =~ m#^[./]#) {
+       ($package,$dstdir) = @ARGV;
+    } elsif (@ARGV==3) {
+       ($package,$suite,$dstdir) = @ARGV;
     } else {
        die;
     }
-    clone();
+    $dstdir ||= "$package";
+    clone($dstdir);
 }
 
 sub branchsuite () {
     my $branch = cmdoutput_errok @git, qw(symbolic-ref HEAD);
     chomp $branch;
-    if ($branch =~ m#^refs/heads/$branchprefix/([^/.]+)$#o) {
+    if ($branch =~ m#$lbranch_re#o) {
        return $1;
     } else {
        return undef;
@@ -534,7 +558,7 @@ sub cmd_build {
     canonicalise_suite();
     runcmd_ordryrun
        qw(git-buildpackage -us -uc --git-no-sign-tags),
-            "--git-debian-branch=".uploadbranch(),
+            "--git-debian-branch=".lbranch(),
             @ARGV;
 }
 
@@ -560,6 +584,8 @@ sub parseopts () {
            while (m/^-./s) {
                if (s/^-n/-/) {
                    $dryrun=1;
+               } elsif (s/^-D/-/) {
+                   open DEBUG, ">&STDERR" or die $!;
                } elsif (s/^-c(.*=.*)//s) {
                    push @git, $1;
                } elsif (s/^-C(.*)//s) {